=== debian/changelog ===
corsixth (0.20-0maemo2) unstable; urgency=low

  * add freetype

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Fri, 29 Mar 2013 08:04:47 -0400

corsixth (0.20-0maemo1) unstable; urgency=low

  * new upstream release

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Thu, 28 Mar 2013 18:48:11 -0400

corsixth (0.11-0maemo2) unstable; urgency=low

  * map right click to x and middle click to z

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Sun,  2 Dec 2012 14:25:00 -0500

corsixth (0.11-0maemo1) unstable; urgency=low

  * new upstream release

 -- Holger Nahrstaedt <holgernahrstaedt@gmx.de>  Fri, 23 Nov 2012 18:36:12 -0500
