=== debian/control ===
Source: corsixth
Section: user/games
Priority: extra
Maintainer: Javier S. Pedro <maemo@javispedro.com>
Build-Depends: debhelper (>= 5), cmake, sharutils, maemo-version, m4, quilt,
 liblua5.1-0-dev, libx11-dev, libsdl1.2-dev, libsdl-mixer1.2-dev, gnupg, bash,
 pkg-config,libfreetype6-dev
XS-Maemo-Optify: none
Standards-Version: 3.7.2

Package: corsixth
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, corsixth-data (= ${source:Version})
Description: Open source clone of Theme Hospital
 This project aims to reimplement the game engine of Theme Hospital,
 and be able to load the original game data files.
 .
 This means that you will need a purchased copy of Theme Hospital, or a copy of
 the demo, in order to use CorsixTH. After most of the original engine has been
 reimplemented in open source code, the project will serve as a base from which
 extensions to the original game can be made.
XSBC-Bugtracker: mailto:holgernahrstaedt@gmx.de
XB-Maemo-Display-Name: CorsixTH
XB-Maemo-Icon-26:
 iVBORw0KGgoAAAANSUhEUgAAADAAAAAwCAYAAABXAvmHAAAAAXNSR0IArs4c6QAA
 AAZiS0dEAP8A/wD/oL2nkwAAAAlwSFlzAAALEwAACxMBAJqcGAAAAAd0SU1FB9oB
 ARcpFL1YJV8AAAExSURBVGje7ZpNDoIwEIVfDQdxp0fwWPQG3ACXHme68xCadMEB
 uMG4EI0/AVtkFJL3klkQSDtfy6QPWqeqCkM552DavqqqiCCEYNKB1fiEECAigKpq
 VVUKwCSsdMu5sB4ti1foMc8VFq7FAxRTNbRv9vBn/35DXq4jgAOA48wA/NkDLa4x
 pAhgO0MAoEs+JgBE1gABCEAAAhCAAMMrca+36VOTuMKuu6gS2/3gnYqvvc1jRzmK
 Gc9tRwAke5uxygGILGICEIAABPj5X4mY+f26NloH2pEA9aaGF28DcOqsR87zuQDl
 rkS5K5P7cMGlzVjskhfWAAEIQAACEIAAE+4PpHqndqYzUG/qZ4i+aIe9zd9moM87
 We/Us4hnVcTWu+oWuh/2EBGbDoxq4JazW/pxmwvxmezfO7OO4AAAAABJRU5ErkJg
 gg==

Package: corsixth-data
Architecture: all
Section: games
Pre-Depends: hildon-application-manager
Recommends: corsixth
Description: Open source clone of Theme Hospital
 This project aims to reimplement the game engine of Theme Hospital,
 and be able to load the original game data files.
 .
 This means that you will need a purchased copy of Theme Hospital, or a copy of
 the demo, in order to use CorsixTH. After most of the original engine has been
 reimplemented in open source code, the project will serve as a base from which
 extensions to the original game can be made.
 .
 This package contains the game logic (as LUA scripts).
